## -*- texinfo -*-
## @deftypefn  {Function File} {} bwulterode ( @var{BW})
## @deftypefnx {Function File} {} bwulterode ( @var{BW},@var{method}) 
## @deftypefnx {Function File} {} bwulterode (@dots{}, @var{conn})
## @end deftypefn

function BW2 = bwulterode(BW, method = 'euclidean', conn = 8)
  
  if (nargin < 1 || nargin > 3)
    print_usage();
  elseif (!ImageValidation (BW))
    error(" The input image must be a numerical or logical image \n");
   elseif (nargin > 1)
    error(" Currently, only BW2 = bwulterode(BW) is implemented \n");
  end
  
  % Distance Transform of Binary Image
  D = bwdist(~BW);
  D = -D;
 
  % Find local minima
  L = watershed(D);
  L(~BW) = 0;
  
  BW2=0*BW;
  for i=1:max(max(L))
    W = min(min(min(D(L==i))));
    BW2(L==i & D==W)=255;
  end
  
  BW2 = cast(BW2,class(BW));
end


function check = ImageValidation (bw)
  
  %Types={'single ',' double ',' int8 ',' int16 ',' int32 ',' uint8 ',' uint16 ',' uint32 '};
 
  check  = ((isnumeric (bw) || isinteger (bw) || isfloat(bw) || islogical(bw)) && ! issparse (bw) && ! isempty (bw));
endfunction